function [mom1,themu,mom2,dthet] = momentsCalcY(inCond,npts,times,params,params1,probs,gplus,gminus,mom1X,RX,mom2X,kap)

gtotal = gplus + gminus;

thet   = 0.5.*(1-erf(kap));

%--------------------------------------------------------------------------

% Derivative of <Theta[x(t)-c]> wrt time

mom2X_old = mom2X;
mom2X     = mom2X + abs(min(mom2X(2:end) - (mom1X(2:end).^2))) + 1e-5;

dthet = (((params.c - mom1X)./(2*(mom2X - (mom1X.^2)))) .*...
    ( (-2*params1.lambda.*mom2X + 2*params1.alpha.*RX + 2*params1.b.*mom1X) -2*mom1X.*(-params1.lambda*mom1X +params1.alpha*probs +params1.b)) +...
    (-params1.lambda*mom1X +params1.alpha*probs +params1.b)) .*...
    (1./(sqrt(2*pi*(mom2X - (mom1X.^2))))).*exp(-((params.c - mom1X).^2)./(2*(mom2X - (mom1X.^2))));

mom2X = mom2X_old;

%--------------------------------------------------------------------------

dx    = 1e-3;
I(1)  = 0;

for i = 1:1000
    
    pI(i+1)  = sum(exp((params.lambda+params1.lambda)*((i-1):dx:i)).*inter((i-1):i,thet(i:(i+1)).*probs(i:(i+1)),(i-1):dx:i).*dx);
   
end

I  = cumsum(pI);
    
%----------- <y(0)> -------------------------------------------------------

mom1(1) = inCond.y;
for w=2:npts  
    h = (times(w)-times(w-1))*0.01;
    for j=2:100
        s = j+100*(w-2);
        mom1(s) = mom1(s-1) + rk(-params.lambda,mom1(s-1),1,1,probs(s-1)*(params.alpha)*thet(s-1)+params.b,probs(s)*(params.alpha)*thet(s)+params.b,h);
    end
    mom1(s+1) = mom1(s) + rk(-params.lambda,mom1(s),1,1,probs(s-1)*(params.alpha)*thet(s-1)+params.b,probs(s)*(params.alpha)*thet(s)+params.b,h);
end

%----------- <theta(0)mu(0)y(0)> ------------------------------------------

themu(1) = thet(1)*(inCond.y);    
for w=2:npts         
    h = (times(w)-times(w-1))*0.01;
    for j=2:100
        s = j+100*(w-2);
        themu(s) = themu(s-1) + rk(-params.lambda,themu(s-1),1,1,mom1(s-1)*(thet(s-1)*(-gtotal(s-1)*probs(s-1)+gplus(s-1))+probs(s-1)*dthet(s-1))+(params.alpha*probs(s-1)+params.b)*thet(s-1)*probs(s-1)+exp(-(params.lambda+params1.lambda)*(s-1))*params.alpha*((thet(s-1)-1)*probs(s-1)*params1.lambda-probs(s-1)*dthet(s-1)-(thet(s-1)-1)*(-gtotal(s-1)*probs(s-1)+gplus(s-1)))*I(s-1),...
            mom1(s)*(thet(s)*(-gtotal(s)*probs(s)+gplus(s))+probs(s)*dthet(s))+(params.alpha*probs(s)+params.b)*thet(s)*probs(s)+exp(-(params.lambda+params1.lambda)*(s))*params.alpha*((thet(s)-1)*probs(s)*params1.lambda-probs(s)*dthet(s)-(thet(s)-1)*(-gtotal(s)*probs(s)+gplus(s)))*I(s),h);
    end
    themu(s+1) = themu(s) + rk(-params.lambda,themu(s),1,1,mom1(s-1)*(thet(s-1)*(-gtotal(s-1)*probs(s-1)+gplus(s-1))+probs(s-1)*dthet(s-1))+(params.alpha*probs(s-1)+params.b)*thet(s-1)*probs(s-1)+exp(-(params.lambda+params1.lambda)*(s-1))*params.alpha*((thet(s-1)-1)*probs(s-1)*params1.lambda-probs(s-1)*dthet(s-1)-(thet(s-1)-1)*(-gtotal(s-1)*probs(s-1)+gplus(s-1)))*I(s-1),...
            mom1(s)*(thet(s)*(-gtotal(s)*probs(s)+gplus(s))+probs(s)*dthet(s))+(params.alpha*probs(s)+params.b)*thet(s)*probs(s)+exp(-(params.lambda+params1.lambda)*(s))*params.alpha*((thet(s)-1)*probs(s)*params1.lambda-probs(s)*dthet(s)-(thet(s)-1)*(-gtotal(s)*probs(s)+gplus(s)))*I(s),h);
end

%----------- <y(0)^2> -----------------------------------------------------

mom2(1) = (inCond.y)^2;  
for w=2:npts         
    h = (times(w)-times(w-1))*0.01;
    for j=2:100
        s = j+100*(w-2);
        mom2(s) = mom2(s-1) + rk(-2*params.lambda,mom2(s-1),1,1,2*(params.alpha)*themu(s-1)+2*(params.b)*mom1(s-1),2*(params.alpha)*themu(s)+2*(params.b)*mom1(s),h);
    end
    mom2(s+1) = mom2(s) + rk(-2*params.lambda,mom2(s),1,1,2*(params.alpha)*themu(s-1)+2*(params.b)*mom1(s-1),2*(params.alpha)*themu(s)+2*(params.b)*mom1(s),h);
end

%--------------------------------------------------------------------------
