function [gplus,gtotal,gminus,params,params1,fplus,fminus,thet,monitorFreeEn]=swEM(dataX,dataY,times,paramPrior,fplus,fminus,inCond,Lrate,Y,gra)

% -------------------------------------------------------------------------
params1.alpha  = paramPrior.alpha1^-1;
params1.b      = paramPrior.b1^-1;
params1.lambda = paramPrior.lambda1^-1;
params1.sigma  = paramPrior.sigma1^-1;

params.alpha   = paramPrior.alpha^-1;
params.b       = paramPrior.b^-1;
params.lambda  = paramPrior.lambda^-1;
params.sigma   = paramPrior.sigma^-1;

params.c       = paramPrior.c^-1;
% -------------------------------------------------------------------------

reDataX    = [inCond.x,dataX];
reDataY    = [inCond.y,dataY];

timesGrid  = [0:1000];
npts       = length(times);

% --------- Initialise transition rates gplus, gminus ---------------------
gplus  = ones(1,1000).*0.001;
gminus = ones(1,1000).*0.001;
gtotal = gplus+gminus;
% -------------------------------------------------------------------------

deltas2 = ones(1,length(gplus));

jj = 0;

while jj<Y

    jj = jj+1; 
    
    old_gplus = gplus;
    old_gminus = gminus;    
    
    probs   = swProbs(gplus,gtotal,deltas2,inCond.prob);
    
    % moments
    [mom1X,RX,mom2X,kap]    = momentsCalc(inCond,npts,times,params1,probs,gplus,gminus,params.c);    
    [mom1Y,QY,mom2Y,dthet]  = momentsCalcY(inCond,npts,times,params,params1,probs,gplus,gminus,mom1X,RX,mom2X,kap);    

    % useful integrals
    [dthetX,dthetX2,IntI,IntIx,IntIx2] = inteCalc(params,params1,mom1X,mom2X,probs,kap);

    % multipliers
    deltaKy = 0.5*(params.sigma);
    deltaFy = -(params.sigma);
    deltaKx = 0.5*(params1.sigma);
    deltaFx = -(params1.sigma);
    
    [kappa,psi,fi]  = moltipCalcY(kap,dthet,gplus,gminus,fplus,fminus,probs,deltaKy,deltaFy,reDataY,params,times,npts);    
    
    [teta,delta,zita,csi] = moltipCalcX(kap,dthet,dthetX,dthetX2,IntI,IntIx,IntIx2,mom1X,RX,mom2X,mom1Y,QY,mom2Y,deltaKx,deltaFx,reDataX,gplus,gminus,fplus,fminus,probs,params,params1,kappa,psi,fi,times,npts);

    [mom1X,RX,mom2X,mom1Y,QY,mom2Y] = shortmoms(mom1X,RX,mom2X,mom1Y,QY,mom2Y);
    
    kappa = kappa(2:end);
    psi   = psi(2:end);
    fi    = fi(2:end);
    teta  = teta(2:end);
    delta = delta(2:end);
    zita  = zita(2:end);    
    csi   = csi(2:end);
    
    thet    = 0.5.*(1-erf(kap(2:end)));
        
    % gradient wrt g
    gradG1 = (1-probs(2:end)).*log(gplus./fplus)  -   (1-probs(2:end)).*csi   +  (RX-mom1X).*delta  +  psi.*(exp(-(params1.lambda+params.lambda)*timesGrid(2:end))*params.alpha.*(thet-1).*IntI(2:end) - mom1Y.*thet).*(1-probs(2:end));
    gradG0 = probs(2:end).*log(gminus./fminus)    +     probs(2:end).*csi     +    RX.*delta        +  psi.*(exp(-(params1.lambda+params.lambda)*timesGrid(2:end))*params.alpha.*(thet-1).*IntI(2:end) - mom1Y.*thet).*(-probs(2:end));
    
    % gradient wrt parameters
    
    thet   = 0.5.*(1-erf(kap));

    gradA1 = - probs(2:end).*(zita+delta) - 2*RX.*teta;    
    gradB1 = - zita -2*mom1X.*teta - probs(2:end).*delta;
    gradL1 = mom1X.*zita + 2*mom2X.*teta + RX.*delta;
    
    [IntLambda] = L1deriv(params,params1,probs,thet);
    
    gradA  = - probs(2:end).*fi.*thet(2:end) - 2*QY.*kappa - psi.*((probs(2:end).^2).*thet(2:end) +...
        exp(-(params.lambda+params1.lambda)*timesGrid(2:end)).*((thet(2:end)-1).*probs(2:end).*params1.lambda -probs(2:end).*dthet(2:end) -(thet(2:end)-1).*(-gtotal.*probs(2:end)+gplus)).*IntI(2:end));    
    gradB  = - fi -2*mom1Y.*kappa - probs(2:end).*psi.*thet(2:end);    
    gradL = mom1Y.*fi + 2*mom2Y.*kappa + QY.*psi +...
        psi.*params.alpha.*exp(-(params.lambda+params1.lambda)*timesGrid(2:end)).*timesGrid(2:end).*((thet(2:end)-1).*probs(2:end).*params1.lambda -probs(2:end).*dthet(2:end) -(thet(2:end)-1).*(-gtotal.*probs(2:end)+gplus)).*IntI(2:end)-...
        psi.*params.alpha.*exp(-(params.lambda+params1.lambda)*timesGrid(2:end)).*((thet(2:end)-1).*probs(2:end).*params1.lambda -probs(2:end).*dthet(2:end) -(thet(2:end)-1).*(-gtotal.*probs(2:end)+gplus)).*IntLambda(2:end);
    
    %======================================================================

    params1.alpha  = params1.alpha  - (sum(gradA1))*10^(-round(log10(abs(sum(gradA1)))+5.0+...
        (round(log10(abs(sum(gradA1))))<3)*(3-round(log10(abs(sum(gradA1)))))));
    params1.b      = params1.b      - (sum(gradB1))*10^(-round(log10(abs(sum(gradB1)))+5.0+...
        (round(log10(abs(sum(gradB1))))<3)*(3-round(log10(abs(sum(gradB1)))))));
    params1.lambda = params1.lambda - (sum(gradL1))*10^(-round(log10(abs(sum(gradL1)))+5.0+...
        (round(log10(abs(sum(gradL1))))<3)*(3-round(log10(abs(sum(gradL1)))))));
    
    params.alpha  = params.alpha  - (sum(gradA))*10^(-round(log10(abs(sum(gradA)))+5.0+...
        (round(log10(abs(sum(gradA))))<3)*(3-round(log10(abs(sum(gradA)))))));
    params.b      = params.b      - (sum(gradB))*10^(-round(log10(abs(sum(gradB)))+5.0+...
        (round(log10(abs(sum(gradB))))<3)*(3-round(log10(abs(sum(gradB)))))));
    params.lambda = params.lambda - (sum(gradL))*10^(-round(log10(abs(sum(gradL)))+5.0+...
        (round(log10(abs(sum(gradL))))<3)*(3-round(log10(abs(sum(gradL)))))));
    
    %======================================================================
    
    gplus = old_gplus - Lrate*(gradG1);
    gminus = old_gminus - Lrate*(gradG0);
    
    for j=1:length(gplus)
        if gplus(j)<1e-6
            gplus(j)=1e-6;
        end
        if gplus(j)>1e-1
            gplus(j)=1e-1;
        end
        if gminus(j)<1e-6
            gminus(j)=1e-6;
        end
        if gminus(j)>1e-1
            gminus(j)=1e-1;
        end
    end
    
    gtotal = gplus+gminus;
    
    % monitoring of variational free energy
    monitorFreeEn(jj) = swLike(dataX,dataY,times,timesGrid,gplus,gminus,params,params1,fplus,fminus,inCond);
    fprintf('%d of %d\n',jj,Y)

    
    if mod(jj,gra)==0

        probs   = swProbs(gplus,gtotal,deltas2,inCond.prob);
        [mom1X,RX,mom2X,kap] = momentsCalc(inCond,npts,times,params1,probs,gplus,gminus,params.c);
        [mom1Y,QY,mom2Y,dthet] = momentsCalcY(inCond,npts,times,params,params1,probs,gplus,gminus,mom1X,RX,mom2X,kap);
        
        figure
        subplot(1,2,1), plot(times,reDataX,'+'), title('x')
        hold on, plot(timesGrid,mom1X,'r-'), grid on
        subplot(1,2,2), plot(times,reDataY,'+'), title('y')
        hold on, plot(timesGrid,mom1Y,'r-'), grid on
        
        pause(1)
        
    end
    
end
    
thet   = 0.5.*(1-erf(kap));
