function [mu,theta,x,y,dataX,dataY] = toyData(params,inX,inY)

p1 = 174;
p2 = 659;

mu = zeros(1,1000); mu([1:p1 p2:end])=1;

x = zeros(1,1000);

x(1)          = inX;
x(2:p1)       = (params.alpha1 + params.b1)/params.lambda1 + (inX-(params.alpha1+params.b1)/params.lambda1)*exp(-params.lambda1*[1:(p1-1)]);
x((p1+1):p2)  = params.b1/params.lambda1+(x(p1)-params.b1/params.lambda1)*exp(-params.lambda1*(1:(p2-p1)));
x((p2+1):end) = (params.alpha1+params.b1)/params.lambda1+(x(p2)-(params.alpha1+params.b1)/params.lambda1)*exp(-params.lambda1*(1:(1000-p2)));

theta = (x >= params.c);

y(1) = inY;

for i=2:1000
    
    y(i) = y(i-1) + rk(-params.lambda,y(i-1),1,1,params.alpha*mu(i-1)*theta(i-1)+params.b,...
        params.alpha*mu(i)*theta(i)+params.b,1);
    
end
    
    
randn('seed',7839)

noise = sqrt(params.sigmaX)*randn(1,10);
dataX = x(100:100:end)+noise;

noise = sqrt(params.sigmaY)*randn(1,10);
dataY = y(100:100:end)+noise;

