function [Inte]=CalcIntegY(gplus,gminus,para,para1,inCond,times)


% Calculation of first and second integrals

timesGrid = 0:1000;
npts      = length(timesGrid);
npts2     = length(times);
deltasD   = ones(1,length(gplus));

inCondNew.y    = inCond.y;
inCondNew.prob = inCond.prob;

paraTemp.b       = 0;
paraTemp.lambda  = para.lambda;
paraTemp.sigma   = para.sigma;
paraTemp.c       = para.c;

paraTemp1.b      = para1.b;
paraTemp1.alpha  = para1.alpha;
paraTemp1.lambda = para1.lambda;
paraTemp1.sigma  = para1.sigma;

probs = swProbs(gplus,gplus+gminus,deltasD,inCond.prob);

[mom1X,RX,mom2X,kap] = momentsCalc(inCond,npts2,times,paraTemp1,probs,gplus,gminus,paraTemp.c);

Inte.inte1_1 = zeros(1,npts-1);
Inte.inte1_2 = zeros(1,npts-1);
Inte.inte2_1 = zeros(1,npts-1);
Inte.inte2_2 = zeros(1,npts-1);
Inte.inte2_3 = zeros(1,npts-1);


% calculation of first integrals

paraTemp.alpha2 = 0;
paraTemp.alpha  = para.alpha;
        
mom1Y = momentsCalcY(inCond,npts2,times,paraTemp,paraTemp1,probs,gplus,gminus,mom1X,RX,mom2X,kap);
        
for j = 2:npts
    Inte.inte1_1(j-1) = (mom1Y(j-1)*exp(paraTemp.lambda*timesGrid(j)))/paraTemp.alpha;
end
        
paraTemp.alpha2 = para.alpha2;
paraTemp.alpha  = 0;
        
mom1Y = momentsCalcY(inCond,npts2,times,paraTemp,paraTemp1,probs,gplus,gminus,mom1X,RX,mom2X,kap);
        
for j = 2:npts
    Inte.inte1_2(j-1) = (mom1Y(j-1)*exp(paraTemp.lambda*timesGrid(j)))/paraTemp.alpha2;
end


% calculation of second integral

paraTemp.alpha2 = 0;
paraTemp.alpha  = para.alpha;
        
[mom1Y,RY,QY,mom2Y] = momentsCalcY(inCond,npts2,times,paraTemp,paraTemp1,probs,gplus,gminus,mom1X,RX,mom2X,kap);
        
for j = 2:npts
    Inte.inte2_1(j-1) = (mom2Y(j-1)*exp(2*paraTemp.lambda*timesGrid(j)))/(paraTemp.alpha^2);
end

paraTemp.alpha2 = para.alpha2;
paraTemp.alpha  = 0;

[mom1Y,RY,QY,mom2Y] = momentsCalcY(inCond,npts2,times,paraTemp,paraTemp1,probs,gplus,gminus,mom1X,RX,mom2X,kap);

for j = 2:npts
    Inte.inte2_2(j-1) = (mom2Y(j-1)*exp(2*paraTemp.lambda*timesGrid(j)))/(paraTemp.alpha2^2);
end

paraTemp.alpha2 = para.alpha2;
paraTemp.alpha  = para.alpha;

[mom1Y,RY,QY,mom2Y] = momentsCalcY(inCond,npts2,times,paraTemp,paraTemp1,probs,gplus,gminus,mom1X,RX,mom2X,kap);

for j = 2:npts
    Inte.inte2_3(j-1) = (mom2Y(j-1)*exp(2*paraTemp.lambda*timesGrid(j)) -(paraTemp.alpha^2)*Inte.inte2_1(j-1) -(paraTemp.alpha2^2)*Inte.inte2_2(j-1))/(2*paraTemp.alpha*paraTemp.alpha2);
end