function [mom1,mommu,mom2,kap] = momentsCalc(inCond,npts,times,params,probs,gplus,gminus,C)

gtotal = gplus + gminus;

%----------- <x(0)> -------------------------------------------------------

mom1(1) = inCond.x;
for w=2:npts  
    h = (times(w)-times(w-1))*0.01;
    for j=2:100
        s = j+100*(w-2);
        mom1(s) = mom1(s-1) + rk(-params.lambda,mom1(s-1),1,1,probs(s-1)*(params.alpha)+params.b,probs(s)*(params.alpha)+params.b,h);
    end
    mom1(s+1) = mom1(s) + rk(-params.lambda,mom1(s),1,1,probs(s-1)*(params.alpha)+params.b,probs(s)*(params.alpha)+params.b,h);
end

%----------- <x(0)mu(0)> --------------------------------------------------

mommu(1) = probs(1)*(inCond.x);    
for w=2:npts         
    h = (times(w)-times(w-1))*0.01;
    for j=2:100
        s = j+100*(w-2);
        mommu(s) = mommu(s-1) + rk(1,mommu(s-1),-(params.lambda+gtotal(s-1)),-(params.lambda+gtotal(s)),(params.alpha+params.b)*probs(s-1)+gplus(s-1)*mom1(s-1),(params.alpha+params.b)*probs(s)+gplus(s)*mom1(s),h);
    end
    mommu(s+1) = mommu(s) + rk(1,mommu(s),-(params.lambda+gtotal(s-1)),-(params.lambda+gtotal(s)),(params.alpha+params.b)*probs(s-1)+gplus(s-1)*mom1(s-1),(params.alpha+params.b)*probs(s)+gplus(s)*mom1(s),h);  
end

%----------- <x(0)^2> -----------------------------------------------------

mom2(1) = (inCond.x)^2;  
for w=2:npts         
    h = (times(w)-times(w-1))*0.01;
    for j=2:100
        s = j+100*(w-2);
        mom2(s) = mom2(s-1) + rk(-2*params.lambda,mom2(s-1),1,1,2*(params.alpha)*mommu(s-1)+2*(params.b)*mom1(s-1),2*(params.alpha)*mommu(s)+2*(params.b)*mom1(s),h);
    end
    mom2(s+1) = mom2(s) + rk(-2*params.lambda,mom2(s),1,1,2*(params.alpha)*mommu(s-1)+2*(params.b)*mom1(s-1),2*(params.alpha)*mommu(s)+2*(params.b)*mom1(s),h);
end

%--------------------------------------------------------------------------

mom2_old = mom2;
mom2     = mom2 + abs(min(mom2(2:end) - (mom1(2:end).^2))) + 1e-5;

kap   = (C-mom1(2:end))./(sqrt(2*(mom2(2:end) - (mom1(2:end).^2))));
kap   = [kap(1) kap(1:end)];

mom2 = mom2_old;