
function []=simulOR(BB)

close all

% -------------------------------- ToyData --------------------------------
params.alpha1  = (3.7e-3);
params.b1      = (0.8e-3);
params.lambda1 = 0.005;
params.sigmaX  = 0.001;

params.alpha   = (2.7e-3);
params.b       = (0.8e-3);
params.lambda  = 0.008;
params.sigmaY  = 0.001;

params.alpha2  = (2.5e-3);
params.c       = 0.42;

inX = 0.84;
inY = 0.4;

[mu,theta,x,y,dataX,dataY] = toyData(params,inX,inY);
% -------------------------------------------------------------------------

times = [100:100:1000];
times = [0,times];

inCond.x    = inX;
inCond.y    = inY;
inCond.prob = 0.99;

fplus  = 1e-4;
fminus = 1e-4;

% ----------------------------- Initialisation ----------------------------
[aa,bb] = incip(times,inX,dataX,200,0.005);

paramPrior.alpha1  = 1/aa;
paramPrior.b1      = 1/bb;
paramPrior.lambda1 = 150;
paramPrior.sigma1  = 0.01;

[aa,bb] = incip(times,inY,dataY,200,0.005);

paramPrior.alpha   = 1/aa;
paramPrior.b       = 1/bb;
paramPrior.lambda  = 150;
paramPrior.sigma   = 0.01;

paramPrior.alpha2  = 1/aa;

paramPrior.c       = 1/BB;

paramPrior.gplus  = 1000*ones(1,length(dataX));
paramPrior.gminus = 1000*ones(1,length(dataX));
% -------------------------------------------------------------------------

Y = 400;             % number of iterations
g = 700;             % number of iterations after each plot

lrate = 0.0001;      % learning rate

[gplus,gtotal,gminus,finParams,finParams1,fplus,fminus,thet,monitorFreeEn]=swEM(dataX,dataY,times,paramPrior,fplus,fminus,inCond,lrate,Y,g);
%--------------------------------------------------------------------------

deltas = ones(1,length(gplus));
probs  = swProbs(gplus,gtotal,deltas,inCond.prob);

% Calculation of error bars
InitCond = inCond;
InitCond.x = 0;
InitCond.y = 0;
errX  = CalcErrBarsX(gplus,gminus,finParams1,finParams,InitCond,times);
ErrX = 2*sqrt(diag(errX)');
errY  = CalcErrBarsY(gplus,gminus,finParams1,finParams,InitCond,times);
ErrY = 2*sqrt(diag(errY)');

% Fitting
reDataX    = [inCond.x,dataX];
reDataY    = [inCond.y,dataY];
timesGrid  = [0:1000];
npts       = length(times);
[mom1X,RX,mom2X,kap] = momentsCalc(inCond,npts,times,finParams1,probs,gplus,gminus,params.c);
[mom1Y] = momentsCalcY(inCond,npts,times,finParams,finParams1,probs,gplus,gminus,mom1X,RX,mom2X,kap);


if BB==0.35
    save C035
end
if BB==0.39
    save C039
end
if BB==0.43
    save C043
end
if BB==0.47
    save C047
end
if BB==0.51
    save C051
end
if BB==0.55
    save C055
end
if BB==0.59
    save C059
end
if BB==0.63
    save C063
end
if BB==0.67
    save C067
end
if BB==0.71
    save C071
end
if BB==0.75
    save C075
end
if BB==0.79
    save C079
end
