function [inParams]=MSInitialize(data, obsTimes, inCond,f)

nStep        = 1000;
inG.plus     = f.plus*ones(1,nStep);
inG.minus    = f.minus*ones(1,nStep);
fullData     = [inCond.x,data];
npts         = size(data,2);
diffFullData = fullData(:,2:end)-fullData(:,1:end-1);

nGenes          = size(data,1);
inParams.A      = zeros(nGenes,1);
inParams.b      = zeros(nGenes,1);
inParams.lambda = zeros(nGenes,1);
signVecs        = sign(diffFullData);


for j=1:nGenes
    
    runMatrix = zeros(npts);
    
    for l=1:npts          
        
        for k=l+1:npts
            
            runMatrix(l,k) = sum(signVecs(j,l:k));
        
        end
    end
    
    [val,ind1]  = max(abs(runMatrix));
    [val2,ind2] = max(abs(val));
    preStartRun = min([ind2,ind1(ind2)]);
    startRun    = min(find(abs(runMatrix(preStartRun,:))));
    endRun      = max([ind2,ind1(ind2)]);
    
    datti = log(data(j,startRun-1:endRun-1)-data(j,endRun));
    tempi = obsTimes(startRun:endRun-1)-obsTimes(startRun-1);
    
    inParams.lambda(j) = abs((datti(2:end)-datti(1))*tempi'/sum(tempi.^2));
    
    inParams.b(j) = inParams.lambda(j)*min(fullData(j,:));
    inParams.b(j) = inParams.b(j)-0.2*inParams.b(j);  %accounts for the fact that maybe minimum is not low steady state
    inParams.A(j) = inParams.lambda(j)*max(fullData(j,:))-inParams.b(j);
    inParams.A(j) = inParams.A(j)+0.2*inParams.A(j);
    
end
        
    