
clear all
close all
clc

params.alpha1  = (3.7e-3);
params.b1      = (0.8e-3);
params.lambda1 = 0.005;
params.sigmaX  = 0.001;

in = 0.84;

[mu,x,data] = toyData(params,in);

obsTimes = [100:100:1000];
times    = [0,obsTimes];

inCond.x    = in;
inCond.prob = 0.99;

f.plus  = 1e-4;
f.minus = 1e-4;

% -------------------------------------------------------------------------

w = 100;

Data = interp1(times,[in data],[0:1000]);
DataInv = Data(end:-1:1);

for i=1:w
    DataF(i) = mean(Data(i:-1:1));
    DataB(i) = mean(DataInv(i:-1:1));
end

for i=w:1:length(Data)
    DataF(i) = mean(Data(i:-1:(i-w+1)));
    DataB(i) = mean(DataInv(i:-1:(i-w+1)));
end

DataB = DataB(end:-1:1);
DataNew = mean([DataF;DataB]);

dataFilt = DataNew([100:100:1000]);

% -------------------------------------------------------------------------

inParams = MSInitialize(dataFilt,obsTimes,inCond,f);

pL = inParams.lambda;

pB = pL*min(DataNew);
pB = pB*0.8;
pA = pL*max(DataNew)-pB;
pA = pA*0.8;
    