function [kappa,psi,fi]=moltipCalcY(kap,dthet,gplus,gminus,fplus,fminus,probs,deltaK,deltaF,reData,params,times,npts)

gtotal  = gplus+gminus;
gtotal_ = [gtotal(end) gtotal(end:-1:1) gtotal(1)];
gplus_  = [gplus(end) gplus(end:-1:1) gplus(1)];

probs_  = [probs(end:-1:1) probs(1)];

thet    = 0.5.*(1-erf(kap));
thet_   = 0.5*([thet(end:-1:1) thet(1)]+[thet(end) thet(end:-1:1)]);

h1 = 0.01;

%--------------------------------------------------------------------------

kappa(1) = 0;
for w=2:npts
    h = (times(w)-times(w-1))*h1;
    s = 1+100*(w-2);
    kappa(s+1) = kappa(s)-deltaK;    
    kappa([2:100]+1+100*(w-2)) = kappa(s+1).*exp(-2*(params.lambda).*[2:100]);
end
kappa = kappa(end:-1:1);

% The other equations are not trivial to be resolved analitycally, since
% they contain terms which depend on time (e.g. g, kappa, etc)

%--------------------------------------------------------------------------

kappa_  = 0.5*([kappa(end:-1:1) kappa(1)]+[kappa(end) kappa(end:-1:1)]);

psi(1) = 0;
for w=2:npts
    h = (times(w)-times(w-1))*h1;
    s = 1+100*(w-2);
    psi(s+1) = psi(s);
    for j=2:100
        s = j+1+100*(w-2);
        psi(s) = psi(s-1) + rk(-(params.lambda),psi(s-1),1,1,2*(params.alpha)*kappa_(s),2*(params.alpha)*kappa_(s+1),h);
    end
end
psi = psi(end:-1:1);

%--------------------------------------------------------------------------

dthet_  = 0.5*([dthet(end:-1:1) dthet(1)]+[dthet(end) dthet(end:-1:1)]);
psi_  = 0.5*([psi(end:-1:1) psi(1)]+[psi(end) psi(end:-1:1)]);

fi(1) = 0;
for w=2:npts
    h = (times(w)-times(w-1))*h1;
    s = 1+100*(w-2);
    fi(s+1) = fi(s)-deltaF*reData(npts-w+2);
    for j=2:100
        s = j+1+100*(w-2);
        fi(s) = fi(s-1) + rk(-(params.lambda),fi(s-1),1,1,2*(params.b)*kappa_(s)+psi_(s)*(thet_(s)*(-gtotal_(s)*probs_(s)+gplus_(s))+probs_(s)*dthet_(s)),2*(params.b)*kappa_(s+1)+psi_(s+1)*(thet_(s+1)*(-gtotal_(s+1)*probs_(s+1)+gplus_(s+1))+probs_(s+1)*dthet_(s+1)),h);
    end
end
fi = fi(end:-1:1);