function val = rk(m,y,a1,a2,b1,b2,h)

%    dy
%    --- = f(t,y) = my(t)a(t) + b(t)
%    dt

%   FORWARD             |    BACKWARD
% -----------------------------------------------------------
%   val --> y(n)        |    val --> y(n)
%   m   --> constant    |    m   --> constant
%   y   --> y(n-1)      |    y   --> y(n-1)
%                       |
%   a1  --> a(n-1)      |    a1  --> A(n)   where A = a(end:-1:1)
%   a2  --> a(n)        |    a2  --> A(n+1)
%                       | 
%   b1  --> b(n-1)      |    b1  --> B(n)   where B = b(end:-1:1)
%   b2  --> b(n)        |    b2  --> B(n+1)


k1 = m*y*a1 + b1;

k2 = m*(y + 0.5*k1*h)*0.5*(a1+a2) + 0.5*(b1 + b2);

k3 = m*(y + 0.5*k2*h)*0.5*(a1+a2) + 0.5*(b1 + b2);

k4 = m*(y + k3*h)*a2 + b2;

val = (1/6)*h*(k1 + 2*k2 + 2*k3 + k4);