
function []=simulAND(BB)

close all

timepoints = [2:2:12];

EndT = length(timepoints)*100;

times = [100:100:EndT];
times = [0,times];

fplus  = 1e-3;
fminus = 1e-3;

inCond.prob = 0.01;

cd human_data; rD = trainTP53; cd ..

% Normalisation
nor = [1000 200 100 200];
for i=1:size(rD,1)
    dataY(i,:)    = rD(i,2:end)/nor(i);
    inCond.y(1,i) = rD(i,1)/nor(i);
end

% Select target genes (DDB2,p21,DRAM,BIK)
seletio  = [1 2 3 4];
inCond.y = inCond.y(seletio);
dataY    = dataY(seletio,:);

tp53sum  = [358.5938  518.7366  492.6063  474.9428  526.4896  420.6138  355.4218];
dataX    = tp53sum(2:end)/tp53sum(1);
inCond.x = 1;

n = size(dataY,1);

% -------------------------------------------------------------------------

cd human_data, rD = trainE2F1; cd ..

ngenes   = size(rD,1);
inSIM    = 1*ones(1,ngenes);
for i=1:ngenes
    dataSIM(i,:)  = rD(i,2:end)/rD(i,1);
end

% Select genes regulated only by E2F1 [p53,MCM7(1),MCM7(2),LIG1,MCM2,MCM5(1), MCM5(2)]
seletio    = [2 3 4 7];
inCond.SIM = inSIM(seletio);
dataSIM    = dataSIM(seletio,:);

nSIM = size(dataSIM,1);

% ----------------------------- Initialisation ----------------------------

paraTemp = importdata('paramTp53.mat');
paramPrior.alpha1  = 1/paraTemp(1);
paramPrior.b1      = 1/paraTemp(2);
paramPrior.lambda1 = 1/paraTemp(3);
paramPrior.sigma1  = 0.03;
clear paraTemp

for j=1:n
    
    [aa,bb] = incip(times,inCond.y(j),dataY(j,:),200,0.005);

    paramPrior.alpha(j)   = 1/aa;
    paramPrior.b(j)       = 1/bb;
    paramPrior.lambda(j)  = 250;
    paramPrior.sigma(j)   = 0.07;
    
end

paramPrior.c       = 1/BB;

% -------------------------------------------------------------------------

for j=1:nSIM
    
    [aa,bb] = incip(times,inCond.SIM(j),dataSIM(j,:),200,0.005);

    paramPrior.alphaSIM(j)   = 1/aa;
    paramPrior.bSIM(j)       = 1/bb;
    paramPrior.lambdaSIM(j)  = 150;
    paramPrior.sigmaSIM(j)   = 0.01;
    
end

paraTemp = importdata('finX.mat');

for j=1:nSIM
    
    paramPrior.alphaSIM(j)   = 1/paraTemp.alpha(seletio(j));
    paramPrior.bSIM(j)       = 1/paraTemp.b(seletio(j));
    paramPrior.lambdaSIM(j)  = 1/paraTemp.lambda(seletio(j));
    paramPrior.sigmaSIM(j)   = 0.01;
    
end

clear paraTemp
% -------------------------------------------------------------------------

Y = 300;            % number of iterations
g = 400;

lrate = 0.0001;

[gplus,gtotal,gminus,finParams,finParams1,finParamsSIM,thet,monitorFreeEn]=swEM(dataX,dataY,dataSIM,times,paramPrior,fplus,fminus,inCond,lrate,Y,g);

%--------------------------------------------------------------------------

deltas = ones(1,length(gplus));
probs  = swProbs(gplus,gtotal,deltas,inCond.prob);

figure, plot(0:0.02:12,probs,'r-.'), grid on, title('Inferred E2F1 posterior activity')
axis([0 12 0 1.03])

figure, barenco = [0.05 0.61 0.95 0.93 0.94 0.585 0.33];
barenco = barenco./max(barenco);
plot(0:0.02:12, thet), grid on, hold on
pl = plot(0:2:12, barenco,'r+-');
set(pl,'Markersize',10,'Linewidth',3)
hold on, plot(0:2:12, barenco,'c')
title('Inferred p53 posterior activity')
legend('inferred')

if BB==1.05
    save C105
end
if BB==1.08
    save C108
end
if BB==1.10
    save C110
end
if BB==1.15
    save C115
end
if BB==1.20
    save C120
end
if BB==1.25
    save C125
end
if BB==1.30
    save C130
end
if BB==1.35
    save C135
end
