function [gplus,gtotal,gminus,params,params1,paramsSIM,thet,monitorFreeEn]=swEM(dataX,dataY,dataSIM,times,paramPrior,fplus,fminus,inCond,Lrate,Y,gra)

n    = size(dataY,1);
nSIM = size(dataSIM,1);

% --------- start with mean of prior --------------------------------------
params1.alpha  = paramPrior.alpha1^-1;
params1.b      = paramPrior.b1^-1;
params1.lambda = paramPrior.lambda1^-1;
params1.sigma  = paramPrior.sigma1^-1;

params.alpha   = paramPrior.alpha.^-1;
params.b       = paramPrior.b.^-1;
params.lambda  = paramPrior.lambda.^-1;
params.sigma   = paramPrior.sigma.^-1;

params.c       = paramPrior.c^-1;

if nSIM>0
    paramsSIM.alpha   = paramPrior.alphaSIM.^-1;
    paramsSIM.b       = paramPrior.bSIM.^-1;
    paramsSIM.lambda  = paramPrior.lambdaSIM.^-1;
    paramsSIM.sigma   = paramPrior.sigmaSIM.^-1;
else
    paramsSIM.alpha   = 0;
    paramsSIM.b       = 0;
    paramsSIM.lambda  = 0;
    paramsSIM.sigma   = 0;
end
% -------------------------------------------------------------------------

reDataX    = [inCond.x,dataX];
reDataY    = [inCond.y',dataY];
reDataSIM  = [inCond.SIM',dataSIM];

EndT = length(dataX)*100;

timesGrid  = [0:EndT];
npts       = length(times);

% --------- Initialise transition rates gplus, gminus ---------------------
gplus  = importdata('gplusX.mat');
gminus = importdata('gminusX.mat');
gtotal = gplus+gminus;
% -------------------------------------------------------------------------

deltas2    = ones(1,length(gplus));

jj = 0;

while jj<=Y

    jj = jj+1; 
    
    old_gplus = gplus;
    old_gminus = gminus;    
    
    probs = swProbs(gplus,gtotal,deltas2,inCond.prob);
        
    % moments
    [mom1X,RX,mom2X,kap] = momentsCalc(inCond,npts,times,params1,probs,gplus,gminus,params.c);
    
    dthet = dthetCalc(params,params1,probs,mom1X,RX,mom2X);
    
    for j=1:n
        [mom1Y(j,:),QY(j,:),mom2Y(j,:)] = momentsCalcY(inCond,npts,times,params,params1,probs,gplus,gminus,kap,dthet,j);
    end
    
    for j=1:nSIM
        paramsSIMtemp.alpha  = paramsSIM.alpha(j);
        paramsSIMtemp.b      = paramsSIM.b(j);
        paramsSIMtemp.lambda = paramsSIM.lambda(j);
        paramsSIMtemp.sigma  = paramsSIM.sigma(j);
        
        inCondtemp.SIM       = inCond.SIM(j);
        
        [mom1SIM(j,:),RSIM(j,:),mom2SIM(j,:)] = momentsCalcSIM(inCondtemp,npts,times,paramsSIMtemp,probs,gplus,gminus);
    end

    % useful integrals
    [dthetX,dthetX2] = dtxCalc(params,mom1X,mom2X);
    for j=1:n        
        [IntI(j,:),IntIx(j,:),IntIx2(j,:)] = inteCalc(dthetX,dthetX2,params,params1,probs,kap,j,EndT);
    end

    % multipliers
    deltaKx = 0.5*(params1.sigma);
    deltaFx = -(params1.sigma);
    
    paraSingle.c = params.c;
    
    for j=1:n
        
        paraSingle.alpha  = params.alpha(j);
        paraSingle.b      = params.b(j);
        paraSingle.lambda = params.lambda(j);
        paraSingle.sigma  = params.sigma(j);
        
        deltaKy = 0.5*(paraSingle.sigma);
        deltaFy = -(paraSingle.sigma);
        
        [kappa(j,:),psi(j,:),fi(j,:)]    = moltipCalcY(kap,dthet,gplus,gminus,fplus,fminus,probs,deltaKy,deltaFy,reDataY(j,:),paraSingle,times,npts);
        
    end
    
    for j=1:nSIM
        
        paraSingle.alpha  = paramsSIM.alpha(j);
        paraSingle.b      = paramsSIM.b(j);
        paraSingle.lambda = paramsSIM.lambda(j);
        paraSingle.sigma  = paramsSIM.sigma(j);
        
        deltaKSIM = 0.5*(paraSingle.sigma);
        deltaFSIM = -(paraSingle.sigma);

        [kappa(j+n,:),psi(j+n,:),fi(j+n,:)]    = moltipCalcSIM(gplus,gminus,deltaKSIM,deltaFSIM,reDataSIM(j,:),paraSingle,times,npts);
        
    end
    
    [teta,delta,zita] = moltipCalcX(kap,dthetX,dthetX2,IntI,IntIx,IntIx2,mom1Y,deltaKx,deltaFx,reDataX,gplus,gminus,probs,params,params1,kappa(1:n,:),psi(1:n,:),fi(1:n,:),times,npts,EndT);   
    
    if nSIM>0
        csi = csiCalc(kap,dthet,IntI,mom1Y,gplus,gminus,fplus,fminus,probs,params,params1,psi(1:n,:),fi(1:n,:),delta,zita,times,npts,psi(n+1:nSIM+n,:),fi(n+1:nSIM+n,:),paramsSIM,EndT);
    else
        csi = csiCalc(kap,dthet,IntI,mom1Y,gplus,gminus,fplus,fminus,probs,params,params1,psi(1:n,:),fi(1:n,:),delta,zita,times,npts,zeros(1,size(psi,2)),zeros(1,size(psi,2)),paramsSIM,EndT);
    end

    % decrease vector length
    mom1Xold = mom1X;
    RXold = RX;
    mom2Xold = mom2X;
    
    if nSIM>0
        [mom1X,RX,mom2X,mom1SIM,RSIM,mom2SIM,mom1Y,QY,mom2Y] = shortmoms(mom1X,RX,mom2X,mom1SIM,RSIM,mom2SIM,mom1Y,QY,mom2Y);
    else
        [mom1X,RX,mom2X,mom1SIM,RSIM,mom2SIM,mom1Y,QY,mom2Y] = shortmoms(mom1X,RX,mom2X,zeros(1,size(mom1X,2)),zeros(1,size(mom1X,2)),zeros(1,size(mom1X,2)),mom1Y,QY,mom2Y);
    end
    
    kappa = kappa(:,2:end);
    psi   = psi(:,2:end);
    fi    = fi(:,2:end);
    teta  = teta(2:end);
    delta = delta(2:end);
    zita  = zita(2:end);    
    csi   = csi(2:end);
    
    thet    = 0.5.*(1-erf(kap(2:end)));
        
    % gradient wrt g
    partGradG1 = 0;
    partGradG0 = 0;
    for j=1:n
        partGradG1 = partGradG1   +  psi(j,:).*(exp(-(params1.lambda+params.lambda(j))*timesGrid(2:end))*params.alpha(j).*(thet-1).*IntI(j,2:end) - mom1Y(j,:).*thet).*(1-probs(2:end));
        partGradG0 = partGradG0   +  psi(j,:).*(exp(-(params1.lambda+params.lambda(j))*timesGrid(2:end))*params.alpha(j).*(thet-1).*IntI(j,2:end) - mom1Y(j,:).*thet).*(-probs(2:end));
    end
    
    for j=1:nSIM
        partGradG1 = partGradG1   +  (RSIM(j,:)-mom1SIM(j,:)).*psi(j+n,:);
        partGradG0 = partGradG0   +  RSIM(j,:).*psi(j+n,:);
    end
        
    gradG1 = (1-probs(2:end)).*log(gplus./fplus)  -   (1-probs(2:end)).*csi   + (RX-mom1X).*delta  +  partGradG1;
    gradG0 = probs(2:end).*log(gminus./fminus)    +     probs(2:end).*csi     +   RX.*delta        +  partGradG0;   
    
    % gradient wrt parameters
    
    thet   = 0.5.*(1-erf(kap));

    gradA1 = - probs(2:end).*(zita+delta) - 2*RX.*teta;    
    gradB1 = - zita -2*mom1X.*teta - probs(2:end).*delta;
    gradL1 = mom1X.*zita + 2*mom2X.*teta + RX.*delta;
    
    for w=1:n
        
        paraSingle.alpha  = params.alpha(w);
        paraSingle.b      = params.b(w);
        paraSingle.lambda = params.lambda(w);
        paraSingle.sigma  = params.sigma(w);
        
        [IntLambda] = L1deriv(paraSingle,params1,probs,thet,EndT);
    
        gradA(w,:)  = - probs(2:end).*fi(w,:) - 2*QY(w,:).*kappa(w,:) - psi(w,:).*((probs(2:end).^2).*thet(2:end) +...
            exp(-(paraSingle.lambda+params1.lambda)*timesGrid(2:end)).*((thet(2:end)-1).*probs(2:end).*params1.lambda -probs(2:end).*dthet(2:end) -(thet(2:end)-1).*(-gtotal.*probs(2:end)+gplus)).*IntI(w,2:end));
    
        gradB(w,:)  = - fi(w,:) -2*mom1Y(w,:).*kappa(w,:) - probs(2:end).*psi(w,:).*thet(2:end);
    
        gradL(w,:) = mom1Y(w,:).*fi(w,:) + 2*mom2Y(w,:).*kappa(w,:) + QY(w,:).*psi(w,:) +...
            psi(w,:).*paraSingle.alpha.*exp(-(paraSingle.lambda+params1.lambda)*timesGrid(2:end)).*timesGrid(2:end).*((thet(2:end)-1).*probs(2:end).*params1.lambda -probs(2:end).*dthet(2:end) -(thet(2:end)-1).*(-gtotal.*probs(2:end)+gplus)).*IntI(w,2:end)-...
            psi(w,:).*paraSingle.alpha.*exp(-(paraSingle.lambda+params1.lambda)*timesGrid(2:end)).*((thet(2:end)-1).*probs(2:end).*params1.lambda -probs(2:end).*dthet(2:end) -(thet(2:end)-1).*(-gtotal.*probs(2:end)+gplus)).*IntLambda(2:end);
        
    end
    
    for w=1:nSIM
        
        paraSingle.alpha  = paramsSIM.alpha(w);
        paraSingle.b      = paramsSIM.b(w);
        paraSingle.lambda = paramsSIM.lambda(w);
        paraSingle.sigma  = paramsSIM.sigma(w);
    
        gradA(w+n,:)  = - probs(2:end).*fi(w+n,:) - 2*RSIM(w,:).*kappa(w+n,:) - psi(w+n,:).*probs(2:end);
    
        gradB(w+n,:)  = - fi(w+n,:) -2*mom1SIM(w,:).*kappa(w+n,:) - probs(2:end).*psi(w+n,:);
    
        gradL(w+n,:) = mom1SIM(w,:).*fi(w+n,:) + 2*mom2SIM(w,:).*kappa(w+n,:) + RSIM(w,:).*psi(w+n,:);
        
    end
    
    %======================================================================

    params1.alpha  = params1.alpha  - (sum(gradA1))*10^(-round(log10(abs(sum(gradA1)))+5.0+...
        (round(log10(abs(sum(gradA1))))<3)*(3-round(log10(abs(sum(gradA1)))))));
    params1.b      = params1.b      - (sum(gradB1))*10^(-round(log10(abs(sum(gradB1)))+5.0+...
        (round(log10(abs(sum(gradB1))))<3)*(3-round(log10(abs(sum(gradB1)))))));
    params1.lambda = params1.lambda - (sum(gradL1))*10^(-round(log10(abs(sum(gradL1)))+5.0+...
        (round(log10(abs(sum(gradL1))))<3)*(3-round(log10(abs(sum(gradL1)))))));
    
    
    for w=1:n
    
        params.alpha(w)  = params.alpha(w)  - (sum(gradA(w,:)))*10^(-round(log10(abs(sum(gradA(w,:))))+5.0+...
            (round(log10(abs(sum(gradA(w,:)))))<3)*(3-round(log10(abs(sum(gradA(w,:))))))));
        params.b(w)      = params.b(w)      - (sum(gradB(w,:)))*10^(-round(log10(abs(sum(gradB(w,:))))+5.0+...
            (round(log10(abs(sum(gradB(w,:)))))<3)*(3-round(log10(abs(sum(gradB(w,:))))))));
        params.lambda(w) = params.lambda(w) - (sum(gradL(w,:)))*10^(-round(log10(abs(sum(gradL(w,:))))+5.0+...
            (round(log10(abs(sum(gradL(w,:)))))<3)*(3-round(log10(abs(sum(gradL(w,:))))))));
    end
    
    for w=(n+1):nSIM
    
        paramsSIM.alpha(w-n)  = paramsSIM.alpha(w-n)  - (sum(gradA(w,:)))*10^(-round(log10(abs(sum(gradA(w,:))))+5.0+...
            (round(log10(abs(sum(gradA(w,:)))))<3)*(3-round(log10(abs(sum(gradA(w,:))))))));
        paramsSIM.b(w-n)      = paramsSIM.b(w-n)      - (sum(gradB(w,:)))*10^(-round(log10(abs(sum(gradB(w,:))))+5.0+...
            (round(log10(abs(sum(gradB(w,:)))))<3)*(3-round(log10(abs(sum(gradB(w,:))))))));
        paramsSIM.lambda(w-n) = paramsSIM.lambda(w-n) - (sum(gradL(w,:)))*10^(-round(log10(abs(sum(gradL(w,:))))+5.0+...
            (round(log10(abs(sum(gradL(w,:)))))<3)*(3-round(log10(abs(sum(gradL(w,:))))))));
    end
    
    %======================================================================
    
    gplus = old_gplus - Lrate*(gradG1);
    gminus = old_gminus - Lrate*(gradG0);
    
    for j=1:length(gplus)
        if gplus(j)<1e-6
            gplus(j)=1e-6;
        end
        if gplus(j)>1e-1
            gplus(j)=1e-1;
        end
        if gminus(j)<1e-6
            gminus(j)=1e-6;
        end
        if gminus(j)>1e-1
            gminus(j)=1e-1;
        end
    end
    
    gtotal = gplus+gminus;
    
    % monitoring of variational free energy
    monitorFreeEn(jj) = swLike(dataX,dataY,dataSIM,times,timesGrid,gplus,gminus,params,params1,paramsSIM,fplus,fminus,inCond);
    fprintf('%d of %d\n',jj,Y)

    clear mom1Y QY mom2Y mom1SIM RSIM mom2SIM kappa psi fi
    
    if mod(jj,gra)==0

        probs   = swProbs(gplus,gtotal,deltas2,inCond.prob);
        [mom1X,RX,mom2X,kap] = momentsCalc(inCond,npts,times,params1,probs,gplus,gminus,params.c);
        dthet = dthetCalc(params,params1,probs,mom1X,RX,mom2X);
        for j=1:n
            [mom1Y(j,:),QY(j,:),mom2Y(j,:)] = momentsCalcY(inCond,npts,times,params,params1,probs,gplus,gminus,kap,dthet,j);
        end
        
        for j=1:nSIM
            paramsSIMtemp.alpha  = paramsSIM.alpha(j);
            paramsSIMtemp.b      = paramsSIM.b(j);
            paramsSIMtemp.lambda = paramsSIM.lambda(j);
            paramsSIMtemp.sigma  = paramsSIM.sigma(j);
        
            inCondtemp.SIM       = inCond.SIM(j);
        
            [mom1SIM(j,:),RSIM(j,:),mom2SIM(j,:)] = momentsCalcSIM(inCondtemp,npts,times,paramsSIMtemp,probs,gplus,gminus);
        end
        
        figure('Position',[35 270 1210 350])
        subplot(1,n+nSIM+1,1), plot(timesGrid,interp1(times,reDataX,[0:EndT]))
        hold on, plot(timesGrid,mom1X,'r-'), grid on
        
        for w=1:n
            subplot(1,n+nSIM+1,w+1), plot(timesGrid,interp1(times,reDataY(w,:),[0:EndT]))
            hold on, plot(timesGrid,mom1Y(w,:),'r-'), grid on
        end
        
        for w=1:nSIM
            subplot(1,n+nSIM+1,w+n+1), plot(timesGrid,interp1(times,reDataSIM(w,:),[0:EndT]))
            hold on, plot(timesGrid,mom1SIM(w,:),'r-'), grid on, title('y (SIM)')
        end

        
        pause(1)
        
    end
    
end
    
thet   = 0.5.*(1-erf(kap));
