function like=swLike(datax,datay,dataSIM,times,timesGrid,gplus,gminus,params,params1,paramsSIM,fplus,fminus,inCond)

n    = size(datay,1);
nSIM = size(dataSIM,1);

npts   = length(times);
gtotal = gplus+gminus;
deltas = ones(1,length(gplus));
probs  = swProbs(gplus,gtotal,deltas,inCond.prob);

intProbs = zeros(1,length(deltas));
for l = 1:length(deltas)
    
    intProbs(l) = gplus(l)*deltas(l)/gtotal(l)-(probs(l)-gplus(l)/gtotal(l))* ...
         exp(gtotal(l)*timesGrid(l))*(exp(-gtotal(l)*timesGrid(l+1))-exp(-gtotal(l)*timesGrid(l)))/gtotal(l);
end

KLpriorBit = intProbs*(gminus.*log(gminus/fminus)+fminus-gminus)'+ ...
    (deltas-intProbs)*(gplus.*log(gplus/fplus)+fplus-gplus)';


[mom1X,RX,mom2X,kap] = momentsCalc(inCond,npts,times,params1,probs,gplus,gminus,params.c);
dthet                = dthetCalc(params,params1,probs,mom1X,RX,mom2X);
    
for j=1:n
    [mom1Y(j,:),QY(j,:),mom2Y(j,:)] = momentsCalcY(inCond,npts,times,params,params1,probs,gplus,gminus,kap,dthet,j);
end
    
for j=1:nSIM
    paramsSIMtemp.alpha  = paramsSIM.alpha(j);
    paramsSIMtemp.b      = paramsSIM.b(j);
    paramsSIMtemp.lambda = paramsSIM.lambda(j);
    paramsSIMtemp.sigma  = paramsSIM.sigma(j);
    inCondtemp.SIM       = inCond.SIM(j);
    
    [mom1SIM(j,:),RSIM(j,:),mom2SIM(j,:)] = momentsCalcSIM(inCondtemp,npts,times,paramsSIMtemp,probs,gplus,gminus);
end


dataBitx         = datax*datax'*params1.sigma;
firstMomentBitx  = datax*(mom1X([100:100:end]))'*params1.sigma;
secondMomentBitx = sum(mom2X([100:100:end]))*params1.sigma;

for j=1:n
    dataBity(j)         = datay(j,:)*datay(j,:)'*params.sigma(j);
    firstMomentBity(j)  = datay(j,:)*(mom1Y(j,[100:100:end]))'*params.sigma(j);
    secondMomentBity(j) = sum(mom2Y(j,[100:100:end]))*params.sigma(j);
end

for j=1:nSIM
    dataBitSIM(j)         = dataSIM(j,:)*dataSIM(j,:)'*paramsSIM.sigma(j);
    firstMomentBitSIM(j)  = dataSIM(j,:)*(mom1SIM(j,[100:100:end]))'*paramsSIM.sigma(j);
    secondMomentBitSIM(j) = sum(mom2SIM(j,[100:100:end]))*paramsSIM.sigma(j);
end

like = -0.5*(dataBitx-2*firstMomentBitx+secondMomentBitx) + 0.5*npts*log(params1.sigma) +...
    sum(-0.5*(dataBity-2*firstMomentBity+secondMomentBity) + 0.5*npts*log(params.sigma)) +...
    sum(-0.5*(dataBitSIM-2*firstMomentBitSIM+secondMomentBitSIM) + 0.5*npts*log(paramsSIM.sigma)) -...
    KLpriorBit;

