clear all
close all
clc


% -------------------------------- ToyData --------------------------------
ngenes = 2; % choose in [1 2 3 4]
p      = 0;

timepoints = [1 2 3 4 5 6];

p              = p+1;
inX(p)         = 1;
params.alpha1  = (3.7e-3);
params.lambda1 = 0.005;
params.b1      = 0.0008;
params.sigmaX  = 0.001;

[mu,x(p,:),dataX(p,:)] = toyData_x(params,inX(p),timepoints);

p              = p+1;
inX(p)         = 1;
params.alpha1  = (3.2e-3);
params.lambda1 = 0.006;
params.b1      = 0.0006;
params.sigmaX  = 0.001;

[mu,x(p,:),dataX(p,:)] = toyData_x(params,inX(p),timepoints);

p              = p+1;
inX(p)         = 1;
params.alpha1  = (3.0e-3);
params.lambda1 = 0.007;
params.b1      = 0.0009;
params.sigmaX  = 0.001;

[mu,x(p,:),dataX(p,:)] = toyData_x(params,inX(p),timepoints);

p              = p+1;
inX(p)         = 1;
params.alpha1  = (3.4e-3);
params.lambda1 = 0.005;
params.b1      = 0.0008;
params.sigmaX  = 0.001;

[mu,x(p,:),dataX(p,:)] = toyData_x(params,inX(p),timepoints);
% -------------------------------------------------------------------------

times = [0,timepoints];

inCond.x    = inX(1:ngenes);
inCond.prob = 0.99;

fplus  = 1e-4;
fminus = 1e-4;

% ----------------------------- Real data ---------------------------------
cd human_data, rD = trainTP53; cd ..


% Normalisation
nor = [1000 200 100 200];
for i=1:size(rD,1)
    dataX(i,:)    = rD(i,2:end)/nor(i);
    inCond.x(1,i) = rD(i,1)/nor(i);
end

% Select target genes (DDB2,p21,DRAM,BIK)
seletio  = [1 2 3 4];
inCond.x = inCond.x(seletio);
dataX    = dataX(seletio,:);
ngenes = size(dataX,1);

inCond.prob = 0.01;
% ----------------------------- Initialisation ----------------------------
for i=1:ngenes
    
    [aa,bb] = incip(times,inX(i),dataX(i,:),200,0.005);
    paramPrior.alpha1(i)  = 1/aa;
    paramPrior.b1(i)      = 1/bb;
    paramPrior.lambda1(i) = 250;
    paramPrior.sigma1(i)  = 0.01;

end
% -------------------------------------------------------------------------

Y = 1000;              % number of iterations
g = 1000;              % number of iterations after each plot

lrate = 0.0001;        % learning rate

% Initialise transition rates using only slave TF's data
[gplusX,gtotalX,gminusX,finX] = swEMonlyX(dataX(1:ngenes,:),times,paramPrior,fplus,fminus,inCond,lrate,Y,g,ngenes);

deltas = ones(1,length(gplusX));
probs  = swProbs(gplusX,gtotalX,deltas,inCond.prob);
figure, plot(probs,'r-.'), grid on

barencoPrediction = [0 210 360 190 135 150 110];
barencoPrediction = barencoPrediction./max(barencoPrediction);
barenco = [0.05 0.61 0.95 0.93 0.94 0.585 0.33];
barenco = barenco./max(barenco);
figure
pl = plot(0:2:12, barenco,'b+'); set(pl,'Markersize',6,'Linewidth',3)
hold on, plot(0:0.02:12,probs,'r'), hold on, plot(0:2:12,barencoPrediction,'k-.'), grid on
legend('experimentally determined p53 activity profile','predicted profile with SIM','predicted profile from Barenco','Location','NorthEastOutside')
axis([0 12 0 1.03])

save SIMp53 probs