function [kappa,psi,fi]=moltipCalc_x(gplus,gminus,deltaK,deltaF,reData,params,times,npts)

gtotal  = gplus+gminus;
gtotal_ = [gtotal(end) gtotal(end:-1:1) gtotal(1)];
gplus_  = [gplus(end) gplus(end:-1:1) gplus(1)];

h = 1;

%--------------------------------------------------------------------------

kappa(1) = 0;
for w=2:npts
    h2 = (times(w)-times(w-1));
    s = 1+times(w-1);
    kappa(s+1) = kappa(s)-deltaK;
    for j=2:h2
        s = j+1+times(w-1);
        kappa(s) = kappa(s-1) + rk(-2*(params.lambda),kappa(s-1),1,1,0,0,h);
    end
end
kappa = kappa(end:-1:1);

% The other equations are not trivial to be resolved analitycally, since
% they contain terms which depend on time (e.g. g, kappa, etc)

%--------------------------------------------------------------------------

kappa_  = 0.5*([kappa(end:-1:1) kappa(1)]+[kappa(end) kappa(end:-1:1)]);

psi(1) = 0;
for w=2:npts
    h2 = (times(w)-times(w-1));
    s = 1+times(w-1);
    psi(s+1) = psi(s);
    for j=2:h2
        s = j+1+times(w-1);
        psi(s) = psi(s-1) + rk(1,psi(s-1),-((params.lambda)+gtotal_(s)),...
            -((params.lambda)+gtotal_(s+1)),2*(params.alpha)*kappa_(s),...
            2*(params.alpha)*kappa_(s+1),h);
    end
end
psi = psi(end:-1:1);

%--------------------------------------------------------------------------

psi_  = 0.5*([psi(end:-1:1) psi(1)]+[psi(end) psi(end:-1:1)]);

fi(1) = 0;
for w=2:npts
    h2 = (times(w)-times(w-1));
    s = 1+times(w-1);
    fi(s+1) = fi(s)-deltaF*reData(npts-w+2);
    for j=2:h2
        s = j+1+times(w-1);
        fi(s) = fi(s-1) + rk(-(params.lambda),fi(s-1),1,1,2*(params.b)*kappa_(s)+gplus_(s)*psi_(s),2*(params.b)*kappa_(s+1)+gplus_(s+1)*psi_(s+1),h);
    end
end
fi = fi(end:-1:1);