function like=swLike(datax,datay,times,timesGrid,gplus,gminus,params,params1,fplus,fminus,inCond)

npts   = length(times);
gtotal = gplus+gminus;
deltas = ones(1,length(gplus));
probs  = swProbs(gplus,gtotal,deltas,inCond.prob);

intProbs = zeros(1,length(deltas));
for l = 1:length(deltas)
    
    intProbs(l) = gplus(l)*deltas(l)/gtotal(l)-(probs(l)-gplus(l)/gtotal(l))* ...
         exp(gtotal(l)*timesGrid(l))*(exp(-gtotal(l)*timesGrid(l+1))-exp(-gtotal(l)*timesGrid(l)))/gtotal(l);
end

KLpriorBit = intProbs*(gminus.*log(gminus/fminus)+fminus-gminus)'+ ...
    (deltas-intProbs)*(gplus.*log(gplus/fplus)+fplus-gplus)';

[mom1X,RX,mom2X,kap]       = momentsCalc(inCond,npts,times,params1,probs,gplus,gminus,params.c);    
[mom1Y,RY,QY,mom2Y,dthet]  = momentsCalcY(inCond,npts,times,params,params1,probs,gplus,gminus,mom1X,RX,mom2X,kap);    

dataBitx         = datax*datax'*params.sigma;
firstMomentBitx  = datax*(mom1X(times(2:end)))'*params1.sigma;
secondMomentBitx = sum(mom2X(times(2:end)))*params1.sigma;

dataBity         = datay*datay'*params.sigma;
firstMomentBity  = datay*(mom1Y(times(2:end)))'*params.sigma;
secondMomentBity = sum(mom2Y(times(2:end)))*params.sigma;

like = -0.5*(dataBitx-2*firstMomentBitx+secondMomentBitx) + 0.5*npts*log(params1.sigma) -...
    0.5*(dataBity-2*firstMomentBity+secondMomentBity) + 0.5*npts*log(params.sigma) -...
    KLpriorBit;