function csi = csiCalc_x(psi,fi,gplus,gminus,fplus,fminus,params,times,npts)

gtotal  = gplus+gminus;
gtotal_ = [gtotal(end) gtotal(end:-1:1) gtotal(1)];
gminus_ = [gminus(end) gminus(end:-1:1) gminus(1)];
gplus_  = [gplus(end) gplus(end:-1:1) gplus(1)];
psi_    = 0.5*([psi(:,end:-1:1) psi(:,1)]+[psi(:,end) psi(:,end:-1:1)]);
fi_     = 0.5*([fi(:,end:-1:1) fi(:,1)]+[fi(:,end) fi(:,end:-1:1)]);

h = 1;

alpha = params.alpha;
beta  = params.b;

csi(1) = 0;
for w=2:npts
    h2 = (times(w)-times(w-1));
    s = 1+times(w-1);
    csi(s+1) = csi(s);        
    for j=2:h2
        
        s = j+1+times(w-1);

        const1 = alpha*fi_(:,s) + (alpha+beta)*psi_(:,s) +...
            (gplus_(s)*log(gplus_(s)/fplus)+fplus-gplus_(s)) -...
            (gminus_(s)*log(gminus_(s)/fminus)+fminus-gminus_(s));
        
        const2 = alpha*fi_(:,s+1) + (alpha+beta)*psi_(:,s+1) +...
            (gplus_(s+1)*log(gplus_(s+1)/fplus)+fplus-gplus_(s+1)) -...
            (gminus_(s+1)*log(gminus_(s+1)/fminus)+fminus-gminus_(s+1));
        
        csi(s) = csi(s-1) + rk(1,csi(s-1),-gtotal_(s),-gtotal_(s+1),const1,const2,h);

    end
end
csi = csi(end:-1:1);