
clear all
close all
clc


% -------------------------------- ToyData --------------------------------
ngenes = 2; % choose in [1 2 3 4]
p      = 0;

timepoints = [1 2 3 4 5 6];

p              = p+1;
inX(p)         = 1;
params.alpha1  = (3.7e-3);
params.lambda1 = 0.005;
params.b1      = 0.0008;
params.sigmaX  = 0.001;

[mu,x(p,:),dataX(p,:)] = toyData_x(params,inX(p),timepoints);

p              = p+1;
inX(p)         = 1;
params.alpha1  = (3.2e-3);
params.lambda1 = 0.006;
params.b1      = 0.0006;
params.sigmaX  = 0.001;

[mu,x(p,:),dataX(p,:)] = toyData_x(params,inX(p),timepoints);

p              = p+1;
inX(p)         = 1;
params.alpha1  = (3.0e-3);
params.lambda1 = 0.007;
params.b1      = 0.0009;
params.sigmaX  = 0.001;

[mu,x(p,:),dataX(p,:)] = toyData_x(params,inX(p),timepoints);

p              = p+1;
inX(p)         = 1;
params.alpha1  = (3.4e-3);
params.lambda1 = 0.005;
params.b1      = 0.0008;
params.sigmaX  = 0.001;

[mu,x(p,:),dataX(p,:)] = toyData_x(params,inX(p),timepoints);
% -------------------------------------------------------------------------

times = [0,timepoints];

inCond.x    = inX(1:ngenes);
inCond.prob = 0.99;

fplus  = 1e-4;
fminus = 1e-4;

% ----------------------------- Real data ---------------------------------
cd human_data, rD = trainE2F1; cd ..

ngenes = size(rD,1);
inX    = 1*ones(1,ngenes);
for i=1:ngenes
    dataX(i,:)  = rD(i,2:end)/rD(i,1);
end

inCond.x    = inX;
inCond.prob = 0.01;
% ----------------------------- Initialisation ----------------------------
for i=1:ngenes
    
    [aa,bb] = incip(times,inX(i),dataX(i,:),200,0.005);
    paramPrior.alpha1(i)  = 1/aa;
    paramPrior.b1(i)      = 1/bb;
    paramPrior.lambda1(i) = 250;
    paramPrior.sigma1(i)  = 0.01;

end
% -------------------------------------------------------------------------

Y = 5000;              % number of iterations
g = 5000;              % number of iterations after each plot

lrate = 0.0001;        % learning rate

% Initialise transition rates using only slave TF's data
[gplusX,gtotalX,gminusX,finX] = swEMonlyX(dataX(1:ngenes,:),times,paramPrior,fplus,fminus,inCond,lrate,Y,g,ngenes);

deltas = ones(1,length(gplusX));
probs  = swProbs(gplusX,gtotalX,deltas,inCond.prob);
figure, plot(probs,'r-.'), grid on

save gplusX gplusX
save gminusX gminusX

paramTp53 = [finX.alpha(1) finX.b(1) finX.lambda(1) finX.sigma(1)];

save paramTp53 paramTp53

save finX finX
